//+------------------------------------------------------------------+
extern int    stoploss   = 0,          //   SL,  0,  SL  
              takeprofit = 0,          //   TP,  0,  TP  
              Magic      = 123456;     //   
extern double Lot        = 0.1;        //  
extern int    slippage   = 3;          //       
extern int    MaxOrders  = 3;          //     BUY  SELL
extern int    CycleCount = 5;          //    
//+------------------------------------------------------------------+
double SL,TP;
int    Total,LastTotal;
string ord;
//+------------------------------------------------------------------+
int start()
   {
   Total=fTotal();
   if((Total==LastTotal&&LastTotal!=0)||Total>=MaxOrders)return(0);
   if(takeprofit!=0)TP=NormalizeDouble(Ask+takeprofit*Point,Digits);else TP=0;
   if(stoploss!=0)SL=NormalizeDouble(Ask-stoploss*Point,Digits);else SL=0;
   if(OPENORDER("Buy")==false)return(0);
   if(takeprofit!=0)TP=NormalizeDouble(Bid-takeprofit*Point,Digits);else TP=0;
   if(stoploss!=0)SL=NormalizeDouble(Bid+stoploss*Point,Digits);else SL=0;
   if(OPENORDER("Sell")==false)return(0);
   LastTotal=fTotal();
   return(0);
}
//+------------------------------------------------------------------+
bool OPENORDER(string ord)
   {
   int error,err;
   while(true)
      { 
      error=-1;
      if(ord=="Buy" )error=OrderSend(Symbol(),OP_BUY, Lot,NormalizeDouble(Ask,Digits),slippage,SL,TP,"BUY",Magic,0,Blue);
      if(ord=="Sell")error=OrderSend(Symbol(),OP_SELL,Lot,NormalizeDouble(Bid,Digits),slippage,SL,TP,"SELL",Magic,0,Red);
      if(error==-1) //  OK
         { 
         ShowERROR();err++;Sleep(2000);RefreshRates();
      }
      else return(true);
      if (err>=CycleCount)break;
   }
   return(false);
} 
//+------------------------------------------------------------------+
void ShowERROR()
   {
   int err=GetLastError();
   switch(err)
      { 
      case 1   : return;
      case 2   : Alert("     ",Symbol());return;
      case 3   : Alert("Error   ",Symbol());return;
      case 130 : Alert("Error   Ticket ",Symbol());return;
      case 134 : Alert("  ",Symbol());return;
      case 146 : Alert("Error    ",Symbol());return;
      case 129 : Alert("Error   ",Symbol());return;
      case 131 : Alert("Error   ",Symbol());return;
      case 4200: Alert("Error    ",Symbol());return;
      default  : Alert("Error " ,err," ",Symbol());return;
   }
}
//+------------------------------------------------------------------+
int fTotal()
   {
   int Tot=OrdersTotal();
   int BuyCount=0,SellCount=0;
   if(Tot>0)
      {
      for(int i=0;i<OrdersTotal();i++)
         {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
            {
            if(OrderSymbol()==Symbol()&&(Magic==0||OrderMagicNumber()==Magic))
               {
               switch (OrderType())
                  {
                  case OP_BUY :BuyCount++; break;
                  case OP_SELL:SellCount++;break;
               }
            }
         }
      }
   }
   return(BuyCount+SellCount);
}
//+------------------------------------------------------------------+